Summary: MySQL client program and shared library
Name: mysql
Version: 3.23.39
Release: 1
Group: Applications/Databases
License: GPL/LGPL
URL: http://www.mysql.com
Packager: Hao Li <hli@wag.caltech.edu>
Source0: http://www.mysql.com/Downloads/MySQL-3.23/mysql-%{version}.tar.gz
Source1: mysql.init
Source2: mysql.logrotate
Source3: my.cnf
BuildRoot: %{_tmppath}/mysql-%{version}-root
Prereq: /sbin/ldconfig, /sbin/install-info, grep
BuildRequires: gperf, perl, db3-devel

%description
MySQL is a multi-user, multi-threaded SQL database server.  SQL is
the most popular database language in the world.  MySQL is a client/server
implementation that consists of a server daemon mysqld and many different
client programs and libraries.  This package contains the MySQL client
programs, the client shared library, and generic MySQL files.


%package server
Summary: MySQL server
Group: Applications/Databases
License: GPL
Prereq: /sbin/chkconfig, /usr/sbin/useradd, /usr/sbin/userdel
Requires: mysql = %{version}, sh-utils

%description server
MySQL is a true multi-user, multi-threaded SQL database server.  SQL is
the most popular database language in the world.  MySQL is a client/server
implementation that consists of a server daemon mysqld and many different
client programs and libraries.  This package contains the MySQL server and
some accompanying files and directories.


%package devel
Summary: MySQL devel
Group: Applications/Databases
License: LGPL
Requires: mysql = %{version}

%description devel
MySQL is a true multi-user, multi-threaded SQL database server.  SQL is
the most popular database language in the world.  MySQL is a client/server
implementation that consists of a server daemon mysqld and many different
client programs and libraries.  This package contains the libraries and
header files that are needed for developing your own MySQL applications.


%prep
%setup -q


%build
CFLAGS="-O6 -mpentiumpro -fomit-frame-pointer" \
CXXFLAGS="-O6 -mpentiumpro -fomit-frame-pointer \
-felide-constructors -fno-exceptions -fno-rtti" \
%configure \
	--localstatedir=/var/lib/mysql \
	--with-unix-socket-path=/var/lib/mysql/mysql.sock \
	--enable-assembler \
	--with-mysqld-user="mysql" \
	--with-libwrap \
	--without-debug \
	--without-bench \
	--without-readline \
	--with-extra-charsets=complex
# Add --with-berkeley-db --with-innodb if you want transaction support.
make

cd Docs
make manual.ps && gzip -9f manual.ps
make manual.pdf
cd ..


%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/etc/{rc.d/init.d,logrotate.d}
mkdir -p $RPM_BUILD_ROOT/var/{run/mysqld,lib/mysql}
install -m0755 %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/mysqld
install -m0644 %{SOURCE2} $RPM_BUILD_ROOT/etc/logrotate.d/mysqld
install -m0755 %{SOURCE3} $RPM_BUILD_ROOT/etc/my.cnf

mkdir -p $RPM_BUILD_ROOT/var/log
touch $RPM_BUILD_ROOT/var/log/mysqld.log


%post
/sbin/install-info %{_infodir}/mysql.info.gz %{_infodir}/dir
if ! grep '^/usr/lib/mysql$' /etc/ld.so.conf > /dev/null 2>&1
then
	echo "/usr/lib/mysql" >> /etc/ld.so.conf
fi
/sbin/ldconfig /usr/lib/mysql

%preun
if [ $1 = 0 ]; then
    /sbin/install-info --delete %{_infodir}/mysql.info.gz %{_infodir}/dir
fi

%postun
if [ $1 = 0 ] ; then
    if grep '^/usr/lib/mysql$' /etc/ld.so.conf > /dev/null 2>&1
    then
	grep -v '^/usr/lib/mysql$' /etc/ld.so.conf \
	    > /etc/ld.so.conf.$$ 2> /dev/null
	mv /etc/ld.so.conf.$$ /etc/ld.so.conf
    fi
    /sbin/ldconfig /usr/lib/mysql
fi


%pre server
/usr/sbin/useradd -M -o -r -d /var/lib/mysql -s /bin/bash \
	-c "MySQL Server" -u 27 mysql > /dev/null 2>&1 || :

%post server
if [ $1 = 1 ]; then
    /sbin/chkconfig --add mysqld
fi

%preun server
if [ $1 = 0 ]; then
    /sbin/chkconfig --del mysqld
fi

%postun server
if [ $1 = 0 ] ; then
	/usr/sbin/userdel mysql > /dev/null 2>&1 || : 
fi
if [ $1 -ge 1 ]; then
    /sbin/service mysqld condrestart >/dev/null 2>&1 || :
fi


%files
%defattr(-,root,root)
%doc COPYING* INSTALL* README
%doc Docs/manual.ps.gz Docs/manual.pdf

# /usr/bin/* except mysqladmin and safe_mysqld
/usr/bin/[a-ln-rt-z]*
/usr/bin/msql2mysql
/usr/bin/mysql
/usr/bin/mysql_*
/usr/bin/mysqlaccess
/usr/bin/mysql[b-z]*
/usr/bin/my_*
/usr/bin/myisam*

%{_infodir}/*
%{_mandir}/man1/*
%dir /usr/lib/mysql
/usr/lib/mysql/libmysqlclient*.so.*
/usr/share/mysql


%files server
%defattr(-,root,root)
%config /etc/my.cnf
%config /etc/rc.d/init.d/mysqld
%config /etc/logrotate.d/mysqld
/usr/bin/mysqladmin
/usr/bin/safe_mysqld
/usr/libexec/*
%attr(0755,mysql,mysql) %dir /var/lib/mysql
%attr(0755,mysql,mysql) %dir /var/run/mysqld
%ghost %attr(0640,mysql,mysql) /var/log/mysqld.log


%files devel
%defattr(-,root,root)
/usr/include/mysql
%dir /usr/lib/mysql
/usr/lib/mysql/*.a
/usr/lib/mysql/*.la
/usr/lib/mysql/libmysqlclient*.so


%clean
rm -rf $RPM_BUILD_ROOT

